package org.greenstone.gatherer.metadata;


import java.io.*;


/** This class represents one metadata (element, value) pair */
public class MetadataValueTableEntry
    extends MetadataValue
{
    private int occurrences = 0;


    public MetadataValueTableEntry(MetadataElement metadata_element, MetadataValueTreeNode metadata_value_tree_node)
    {
	super(metadata_element, metadata_value_tree_node);

	occurrences = 1;
    }


    public MetadataValueTableEntry(MetadataValue metadata_value)
    {
	this(metadata_value.getMetadataElement(), metadata_value.getMetadataValueTreeNode());
	inheritsMetadataFromFolder(metadata_value.getFolderMetadataInheritedFrom());
    }


    public void anotherOccurrence()
    {
	occurrences++;
    }


    public int getOccurrences()
    {
	return occurrences;
    }


    public void setOccurrences(int occurrences)
    {
	this.occurrences = occurrences;
    }
}
